#  ARTUR VINAS FERRAN
#  FIRST IMPLEMENTATION
#  ---------------------------------------------------------------------------------------------------------
#  ---------------------------------------------------------------------------------------------------------
#  We import os to verify that the inputs and output do path and files do exist
import os
#  We use argparse tu execute the file with the inputs and outputs from the terminal directly
import argparse

class Concatenator():
    def __init__(self):
        pass
    @staticmethod
    def read_arguments():
        parser = argparse.ArgumentParser(description='Process_files')
        #  Define the inputs ('i' and 'o') and the output ('o')
        parser.add_argument('-i', type=str, required=True, help="The path of the first input")
        parser.add_argument("-g", type=str, required=True, help="The path of the second input")
        parser.add_argument("-o", type=str, required=True, help="The path of the output file")
        parser.add_argument("-n", type=str, required=False, help="The name of the output file (optional)")
        args = parser.parse_args()
        #  Assign the inputs and output given to different variables
        input_path_1 = args.i
        input_path_2 = args.g
        output_path = args.o
        output_name = args.n
        return input_path_1, input_path_2, output_path, output_name

    @staticmethod
    def check(input_path_1, input_path_2, output_path):
        #  Confirm that both input and output files and directories do exist.
        #  In case of error the program will stop and indicate where the error comes from
        #  Input 1
        if not os.path.exists(input_path_1):
            print("The file or directory from the first input (or both) does not exist")
            exit()
        if not os.path.exists(input_path_2):
            print("The file or directory from the second input (or both) does not exist")
            exit()
        if not os.path.isdir(output_path):
            print("The directory of the output file doesn't exist")
            exit()
        #  We read both input files

        doc1 = open(input_path_1).read()
        doc2 = open(input_path_2).read()
        return doc1, doc2

    @staticmethod
    def compute(doc1, doc2, output_name, output_path):
        #  Create a new doc and concatenate both files
        #  If the name of the output file is not given
        if output_name is None:
            doc3 = open(output_path + "/document3.txt", 'a')
        #  If the name of the output file is given
        else:
            doc3 = open(output_path + "/" + output_name, 'a')
        doc3.write(doc1)
        doc3.write(doc2)
        doc3.close()
        return None

    def main(self):
        #  We read the arguments (input files and output directory)
        input_path_1, input_path_2, output_path, output_name = self.read_arguments()
        #  We check that they exist
        doc1, doc2 = self.check(input_path_1, input_path_2, output_path)
        #  We generate the concatenation file of the two initial input files
        self.compute(doc1, doc2, output_name, output_path)

@staticmethod
def run():
    concatenate = Concatenator()
    concatenate.main()

if __name__ == '__main__':
    run()
